#ifndef __DBUS_PROXY_CONEXUS_DBUS_FILEDESCRIPTOR_H
#define __DBUS_PROXY_CONEXUS_DBUS_FILEDESCRIPTOR_H

#include <dbus-cxx.h>

#include <conexus/filedescriptor.h>

#include <conexus-dbus/endpoint_proxy.h>


namespace Conexus {
  namespace DBus {

    class FileDescriptorProxy : public EndpointProxy
    {
      protected:
        FileDescriptorProxy( ::DBus::Connection::pointer conn, const std::string& dest="Conexus.FileDescriptor", const std::string& path="/Conexus/FileDescriptor"):
          EndpointProxy(conn, dest, path)
        {
          ::DBus::Path child_path;

          m_method_is_blocking_b = this->create_method< bool >( "Conexus.FileDescriptor", "is_blocking" );
          m_method_set_blocking_bb = this->create_method< bool,bool >( "Conexus.FileDescriptor", "set_blocking" );
        }

      public:

        typedef DBusCxxPointer<FileDescriptorProxy> pointer;

        static pointer create( ::DBus::Connection::pointer conn,
                               const std::string& dest="Conexus.FileDescriptor",
                               const std::string& path="/Conexus/FileDescriptor"
                             )
        { return pointer( new FileDescriptorProxy(conn, dest, path)); }


        bool is_blocking( ) { return (*m_method_is_blocking_b)(); }

        bool set_blocking( bool block ) { return (*m_method_set_blocking_bb)( block); }


      protected:


        ::DBus::MethodProxy<bool>::pointer m_method_is_blocking_b;
        ::DBus::MethodProxy<bool,bool>::pointer m_method_set_blocking_bb;


    };

  }
}

#endif
