#ifndef __DBUS_ADAPTER_CONEXUS_DBUS_IPV4_ADDRESS_H
#define __DBUS_ADAPTER_CONEXUS_DBUS_IPV4_ADDRESS_H

#include <dbus-cxx.h>

#include <conexus/ipv4_address.h>


namespace Conexus {
  namespace DBus {
    namespace IPv4 {

      class AddressAdapter : public ::DBus::Object
      {
        protected:
          AddressAdapter( Conexus::IPv4::Address* adaptee=NULL, const std::string& path="/Conexus/IPv4/Address"):
            ::DBus::Object(path),
            m_adaptee(adaptee)
          {

            ::DBus::MethodBase::pointer temp_method;

            temp_method = this->create_method<uint32_t>( "Conexus.IPv4.Address", "host", sigc::mem_fun(*this, &AddressAdapter::host_adapter_stub_u) );
            temp_method->set_arg_name( 0, "result" );
            temp_method = this->create_method<std::string>( "Conexus.IPv4.Address", "host_string", sigc::mem_fun(*this, &AddressAdapter::host_string_adapter_stub_s) );
            temp_method->set_arg_name( 0, "result" );
            temp_method = this->create_method<uint32_t>( "Conexus.IPv4.Address", "subnet_mask", sigc::mem_fun(*this, &AddressAdapter::subnet_mask_adapter_stub_u) );
            temp_method->set_arg_name( 0, "result" );
            temp_method = this->create_method<std::string>( "Conexus.IPv4.Address", "subnet_mask_string", sigc::mem_fun(*this, &AddressAdapter::subnet_mask_string_adapter_stub_s) );
            temp_method->set_arg_name( 0, "result" );
            temp_method = this->create_method<uint32_t>( "Conexus.IPv4.Address", "prefix_length", sigc::mem_fun(*this, &AddressAdapter::prefix_length_adapter_stub_u) );
            temp_method->set_arg_name( 0, "result" );
            temp_method = this->create_method<std::string>( "Conexus.IPv4.Address", "prefix_length_string", sigc::mem_fun(*this, &AddressAdapter::prefix_length_string_adapter_stub_s) );
            temp_method->set_arg_name( 0, "result" );
            temp_method = this->create_method<std::string>( "Conexus.IPv4.Address", "host_subnet_mask_string", sigc::mem_fun(*this, &AddressAdapter::host_subnet_mask_string_adapter_stub_s) );
            temp_method->set_arg_name( 0, "result" );
            temp_method = this->create_method<std::string>( "Conexus.IPv4.Address", "cidr_host_string", sigc::mem_fun(*this, &AddressAdapter::cidr_host_string_adapter_stub_s) );
            temp_method->set_arg_name( 0, "result" );
            temp_method = this->create_method<uint32_t>( "Conexus.IPv4.Address", "prefix", sigc::mem_fun(*this, &AddressAdapter::prefix_adapter_stub_u) );
            temp_method->set_arg_name( 0, "result" );
            temp_method = this->create_method<std::string>( "Conexus.IPv4.Address", "prefix_string", sigc::mem_fun(*this, &AddressAdapter::prefix_string_adapter_stub_s) );
            temp_method->set_arg_name( 0, "result" );
            temp_method = this->create_method<uint32_t>( "Conexus.IPv4.Address", "broadcast_address", sigc::mem_fun(*this, &AddressAdapter::broadcast_address_adapter_stub_u) );
            temp_method->set_arg_name( 0, "result" );
            temp_method = this->create_method<std::string>( "Conexus.IPv4.Address", "broadcast_address_string", sigc::mem_fun(*this, &AddressAdapter::broadcast_address_string_adapter_stub_s) );
            temp_method->set_arg_name( 0, "result" );
            temp_method = this->create_method<uint32_t>( "Conexus.IPv4.Address", "local_address", sigc::mem_fun(*this, &AddressAdapter::local_address_adapter_stub_u) );
            temp_method->set_arg_name( 0, "result" );
            temp_method = this->create_method<std::string>( "Conexus.IPv4.Address", "local_address_string", sigc::mem_fun(*this, &AddressAdapter::local_address_string_adapter_stub_s) );
            temp_method->set_arg_name( 0, "result" );
            temp_method = this->create_method<uint16_t>( "Conexus.IPv4.Address", "port", sigc::mem_fun(*this, &AddressAdapter::port_adapter_stub_q) );
            temp_method->set_arg_name( 0, "result" );
            temp_method = this->create_method<std::string>( "Conexus.IPv4.Address", "port_string", sigc::mem_fun(*this, &AddressAdapter::port_string_adapter_stub_s) );
            temp_method->set_arg_name( 0, "result" );
            temp_method = this->create_method<void,uint32_t>( "Conexus.IPv4.Address", "set_host", sigc::mem_fun(*this, &AddressAdapter::set_host_adapter_stub_vu) );
            temp_method->set_arg_name( 1, "host" );
            temp_method = this->create_method<void,std::string>( "Conexus.IPv4.Address", "set_host", sigc::mem_fun(*this, &AddressAdapter::set_host_adapter_stub_vs) );
            temp_method->set_arg_name( 1, "host" );
            temp_method = this->create_method<void,std::string,uint16_t>( "Conexus.IPv4.Address", "set_host", sigc::mem_fun(*this, &AddressAdapter::set_host_adapter_stub_vsq) );
            temp_method->set_arg_name( 1, "host" );
            temp_method->set_arg_name( 2, "port" );
            temp_method = this->create_method<void,uint32_t,uint32_t>( "Conexus.IPv4.Address", "set_host_subnet_mask", sigc::mem_fun(*this, &AddressAdapter::set_host_subnet_mask_adapter_stub_vuu) );
            temp_method->set_arg_name( 1, "host" );
            temp_method->set_arg_name( 2, "subnet_mask" );
            temp_method = this->create_method<void,uint32_t,uint32_t>( "Conexus.IPv4.Address", "set_host_prefix_length", sigc::mem_fun(*this, &AddressAdapter::set_host_prefix_length_adapter_stub_vuu) );
            temp_method->set_arg_name( 1, "host" );
            temp_method->set_arg_name( 2, "prefix_length" );
            temp_method = this->create_method<void,uint32_t>( "Conexus.IPv4.Address", "set_subnet_mask", sigc::mem_fun(*this, &AddressAdapter::set_subnet_mask_adapter_stub_vu) );
            temp_method->set_arg_name( 1, "subnet_mask" );
            temp_method = this->create_method<void,std::string>( "Conexus.IPv4.Address", "set_subnet_mask", sigc::mem_fun(*this, &AddressAdapter::set_subnet_mask_adapter_stub_vs) );
            temp_method->set_arg_name( 1, "subnet_mask" );
            temp_method = this->create_method<void,uint32_t>( "Conexus.IPv4.Address", "set_prefix_length", sigc::mem_fun(*this, &AddressAdapter::set_prefix_length_adapter_stub_vu) );
            temp_method->set_arg_name( 1, "prefix_length" );
            temp_method = this->create_method<void,std::string>( "Conexus.IPv4.Address", "set_prefix_length", sigc::mem_fun(*this, &AddressAdapter::set_prefix_length_adapter_stub_vs) );
            temp_method->set_arg_name( 1, "prefix_length" );
            temp_method = this->create_method<void,uint16_t>( "Conexus.IPv4.Address", "set_port", sigc::mem_fun(*this, &AddressAdapter::set_port_adapter_stub_vq) );
            temp_method->set_arg_name( 1, "port" );
            temp_method = this->create_method<void,std::string>( "Conexus.IPv4.Address", "set_port", sigc::mem_fun(*this, &AddressAdapter::set_port_adapter_stub_vs) );
            temp_method->set_arg_name( 1, "port" );
            temp_method = this->create_method<bool,std::string>( "Conexus.IPv4.Address", "is_valid_hostname", sigc::mem_fun(*this, &AddressAdapter::is_valid_hostname_adapter_stub_bs) );
            temp_method->set_arg_name( 0, "result" );
            temp_method->set_arg_name( 1, "name" );
            temp_method = this->create_method<std::string>( "Conexus.IPv4.Address", "hostname", sigc::mem_fun(*this, &AddressAdapter::hostname_adapter_stub_s) );
            temp_method->set_arg_name( 0, "result" );
            temp_method = this->create_method<std::string>( "Conexus.IPv4.Address", "servicename", sigc::mem_fun(*this, &AddressAdapter::servicename_adapter_stub_s) );
            temp_method->set_arg_name( 0, "result" );
            temp_method = this->create_method<bool>( "Conexus.IPv4.Address", "is_private", sigc::mem_fun(*this, &AddressAdapter::is_private_adapter_stub_b) );
            temp_method->set_arg_name( 0, "result" );
            temp_method = this->create_method<bool>( "Conexus.IPv4.Address", "is_reserved", sigc::mem_fun(*this, &AddressAdapter::is_reserved_adapter_stub_b) );
            temp_method->set_arg_name( 0, "result" );
            temp_method = this->create_method<bool>( "Conexus.IPv4.Address", "is_loopback", sigc::mem_fun(*this, &AddressAdapter::is_loopback_adapter_stub_b) );
            temp_method->set_arg_name( 0, "result" );
            temp_method = this->create_method<bool>( "Conexus.IPv4.Address", "is_broadcast", sigc::mem_fun(*this, &AddressAdapter::is_broadcast_adapter_stub_b) );
            temp_method->set_arg_name( 0, "result" );
            temp_method = this->create_method<bool>( "Conexus.IPv4.Address", "is_multicast", sigc::mem_fun(*this, &AddressAdapter::is_multicast_adapter_stub_b) );
            temp_method->set_arg_name( 0, "result" );
            temp_method = this->create_method<bool>( "Conexus.IPv4.Address", "is_any", sigc::mem_fun(*this, &AddressAdapter::is_any_adapter_stub_b) );
            temp_method->set_arg_name( 0, "result" );
            temp_method = this->create_method<bool>( "Conexus.IPv4.Address", "is_ipv4", sigc::mem_fun(*this, &AddressAdapter::is_ipv4_adapter_stub_b) );
            temp_method->set_arg_name( 0, "result" );
            temp_method = this->create_method<bool>( "Conexus.IPv4.Address", "is_ipv6", sigc::mem_fun(*this, &AddressAdapter::is_ipv6_adapter_stub_b) );
            temp_method->set_arg_name( 0, "result" );
            m_signal_adapter_changed = this->create_signal<void>("Conexus.IPv4.Address","changed");
            if ( m_adaptee ) m_signal_adapter_connection_changed = m_adaptee->signal_changed().connect( *m_signal_adapter_changed );
            m_signal_adapter_host_changed = this->create_signal<void>("Conexus.IPv4.Address","host_changed");
            if ( m_adaptee ) m_signal_adapter_connection_host_changed = m_adaptee->signal_host_changed().connect( *m_signal_adapter_host_changed );
            m_signal_adapter_port_changed = this->create_signal<void>("Conexus.IPv4.Address","port_changed");
            if ( m_adaptee ) m_signal_adapter_connection_port_changed = m_adaptee->signal_port_changed().connect( *m_signal_adapter_port_changed );
            m_signal_adapter_prefix_changed = this->create_signal<void>("Conexus.IPv4.Address","prefix_changed");
            if ( m_adaptee ) m_signal_adapter_connection_prefix_changed = m_adaptee->signal_prefix_changed().connect( *m_signal_adapter_prefix_changed );
          }

        public:

          typedef DBusCxxPointer<AddressAdapter> pointer;

          static pointer create( Conexus::IPv4::Address* adaptee=NULL, const std::string& path="/Conexus/IPv4/Address")
            { return pointer( new AddressAdapter(adaptee, path)); }

          Conexus::IPv4::Address* adaptee() { return m_adaptee; }

          void set_adaptee( Conexus::IPv4::Address* adaptee ) {
            m_adaptee = adaptee;
            m_signal_adapter_connection_changed.disconnect();
            m_signal_adapter_connection_host_changed.disconnect();
            m_signal_adapter_connection_port_changed.disconnect();
            m_signal_adapter_connection_prefix_changed.disconnect();
            if ( m_adaptee ) m_signal_adapter_connection_changed = m_adaptee->signal_changed().connect( *m_signal_adapter_changed );
            if ( m_adaptee ) m_signal_adapter_connection_host_changed = m_adaptee->signal_host_changed().connect( *m_signal_adapter_host_changed );
            if ( m_adaptee ) m_signal_adapter_connection_port_changed = m_adaptee->signal_port_changed().connect( *m_signal_adapter_port_changed );
            if ( m_adaptee ) m_signal_adapter_connection_prefix_changed = m_adaptee->signal_prefix_changed().connect( *m_signal_adapter_prefix_changed );
          }

          void set_adaptee( Conexus::IPv4::Address& adaptee ) {
            this->set_adaptee(&adaptee);
          }


        private:

          Conexus::IPv4::Address* m_adaptee;


          void check_adaptee() { if ( not m_adaptee) throw ::DBus::ErrorInvalidAdaptee(); }

          uint32_t host_adapter_stub_u( ) { this->check_adaptee(); return m_adaptee->host(); }
          std::string host_string_adapter_stub_s( ) { this->check_adaptee(); return m_adaptee->host_string(); }
          uint32_t subnet_mask_adapter_stub_u( ) { this->check_adaptee(); return m_adaptee->subnet_mask(); }
          std::string subnet_mask_string_adapter_stub_s( ) { this->check_adaptee(); return m_adaptee->subnet_mask_string(); }
          uint32_t prefix_length_adapter_stub_u( ) { this->check_adaptee(); return m_adaptee->prefix_length(); }
          std::string prefix_length_string_adapter_stub_s( ) { this->check_adaptee(); return m_adaptee->prefix_length_string(); }
          std::string host_subnet_mask_string_adapter_stub_s( ) { this->check_adaptee(); return m_adaptee->host_subnet_mask_string(); }
          std::string cidr_host_string_adapter_stub_s( ) { this->check_adaptee(); return m_adaptee->cidr_host_string(); }
          uint32_t prefix_adapter_stub_u( ) { this->check_adaptee(); return m_adaptee->prefix(); }
          std::string prefix_string_adapter_stub_s( ) { this->check_adaptee(); return m_adaptee->prefix_string(); }
          uint32_t broadcast_address_adapter_stub_u( ) { this->check_adaptee(); return m_adaptee->broadcast_address(); }
          std::string broadcast_address_string_adapter_stub_s( ) { this->check_adaptee(); return m_adaptee->broadcast_address_string(); }
          uint32_t local_address_adapter_stub_u( ) { this->check_adaptee(); return m_adaptee->local_address(); }
          std::string local_address_string_adapter_stub_s( ) { this->check_adaptee(); return m_adaptee->local_address_string(); }
          uint16_t port_adapter_stub_q( ) { this->check_adaptee(); return m_adaptee->port(); }
          std::string port_string_adapter_stub_s( ) { this->check_adaptee(); return m_adaptee->port_string(); }
          void set_host_adapter_stub_vu( uint32_t host ) { this->check_adaptee(); m_adaptee->set_host( host); }
          void set_host_adapter_stub_vs( std::string host ) { this->check_adaptee(); m_adaptee->set_host( host); }
          void set_host_adapter_stub_vsq( std::string host, uint16_t port ) { this->check_adaptee(); m_adaptee->set_host( host, port); }
          void set_host_subnet_mask_adapter_stub_vuu( uint32_t host, uint32_t subnet_mask ) { this->check_adaptee(); m_adaptee->set_host_subnet_mask( host, subnet_mask); }
          void set_host_prefix_length_adapter_stub_vuu( uint32_t host, uint32_t prefix_length ) { this->check_adaptee(); m_adaptee->set_host_prefix_length( host, prefix_length); }
          void set_subnet_mask_adapter_stub_vu( uint32_t subnet_mask ) { this->check_adaptee(); m_adaptee->set_subnet_mask( subnet_mask); }
          void set_subnet_mask_adapter_stub_vs( std::string subnet_mask ) { this->check_adaptee(); m_adaptee->set_subnet_mask( subnet_mask); }
          void set_prefix_length_adapter_stub_vu( uint32_t prefix_length ) { this->check_adaptee(); m_adaptee->set_prefix_length( prefix_length); }
          void set_prefix_length_adapter_stub_vs( std::string prefix_length ) { this->check_adaptee(); m_adaptee->set_prefix_length( prefix_length); }
          void set_port_adapter_stub_vq( uint16_t port ) { this->check_adaptee(); m_adaptee->set_port( port); }
          void set_port_adapter_stub_vs( std::string port ) { this->check_adaptee(); m_adaptee->set_port( port); }
          bool is_valid_hostname_adapter_stub_bs( std::string name ) { this->check_adaptee(); return m_adaptee->is_valid_hostname( name); }
          std::string hostname_adapter_stub_s( ) { this->check_adaptee(); return m_adaptee->hostname(); }
          std::string servicename_adapter_stub_s( ) { this->check_adaptee(); return m_adaptee->servicename(); }
          bool is_private_adapter_stub_b( ) { this->check_adaptee(); return m_adaptee->is_private(); }
          bool is_reserved_adapter_stub_b( ) { this->check_adaptee(); return m_adaptee->is_reserved(); }
          bool is_loopback_adapter_stub_b( ) { this->check_adaptee(); return m_adaptee->is_loopback(); }
          bool is_broadcast_adapter_stub_b( ) { this->check_adaptee(); return m_adaptee->is_broadcast(); }
          bool is_multicast_adapter_stub_b( ) { this->check_adaptee(); return m_adaptee->is_multicast(); }
          bool is_any_adapter_stub_b( ) { this->check_adaptee(); return m_adaptee->is_any(); }
          bool is_ipv4_adapter_stub_b( ) { this->check_adaptee(); return m_adaptee->is_ipv4(); }
          bool is_ipv6_adapter_stub_b( ) { this->check_adaptee(); return m_adaptee->is_ipv6(); }
          ::DBus::signal<void>::pointer m_signal_adapter_changed;
          sigc::connection m_signal_adapter_connection_changed;
          ::DBus::signal<void>::pointer m_signal_adapter_host_changed;
          sigc::connection m_signal_adapter_connection_host_changed;
          ::DBus::signal<void>::pointer m_signal_adapter_port_changed;
          sigc::connection m_signal_adapter_connection_port_changed;
          ::DBus::signal<void>::pointer m_signal_adapter_prefix_changed;
          sigc::connection m_signal_adapter_connection_prefix_changed;


      };

    }
  }
}

#endif
