#ifndef __DBUS_ADAPTER_CONEXUS_DBUS_IPV4_TCP_H
#define __DBUS_ADAPTER_CONEXUS_DBUS_IPV4_TCP_H

#include <dbus-cxx.h>

#include <conexus/ipv4_tcp.h>

#include <conexus-dbus/ipv4_ip_adapter.h>


namespace Conexus {
  namespace DBus {
    namespace IPv4 {

      class TCPAdapter : public IPAdapter
      {
        protected:
          TCPAdapter( Conexus::IPv4::TCP* adaptee=NULL, const std::string& path="/Conexus/IPv4/TCP"):
            IPAdapter(adaptee, path),
            m_adaptee(adaptee)
          {

            ::DBus::MethodBase::pointer temp_method;

          }

        public:

          typedef DBusCxxPointer<TCPAdapter> pointer;

          static pointer create( Conexus::IPv4::TCP* adaptee=NULL, const std::string& path="/Conexus/IPv4/TCP")
            { return pointer( new TCPAdapter(adaptee, path)); }

          Conexus::IPv4::TCP* adaptee() { return m_adaptee; }

          void set_adaptee( Conexus::IPv4::TCP* adaptee ) {
            m_adaptee = adaptee;
          }

          void set_adaptee( Conexus::IPv4::TCP& adaptee ) {
            this->set_adaptee(&adaptee);
          }


        private:

          Conexus::IPv4::TCP* m_adaptee;


          void check_adaptee() { if ( not m_adaptee) throw ::DBus::ErrorInvalidAdaptee(); }



      };

    }
  }
}

#endif
